<%
'aspsms_xml.asp
'2004-2020 by aspsms.com

Class ASPSMS_XML
    'Version 1.1.3
    '22.12.2020 by aspsms.com

    '--- Private Member Variables --------------------------

    Private m_nRandomNumber

    Private m_sXmlInterfaceUrl
    Private m_sXmlServicesInterfaceUrl

    Private m_sXmlLog

    Private m_nErrorCode
    Private m_sErrorDescription

    Private m_sPasswordFileLocation
    Private m_sUserkey
    Private m_sPassword

    Private m_nUsedCredits

    Private m_sPhoneNumber
    Private m_sXmlRecipients
    Private m_sXmlTransRefNumbers

    Private m_sOriginator
    Private m_sOriginatorUnlockCode

    Private m_bFlashingSMS
    Private m_bBlinkingSMS
    Private m_nReplaceMessage

    Private m_sXser
    Private m_sMessageData

    Private m_nMCC
    Private m_nMNC

    Private m_sURLBinaryFile

    Private m_sVCardName
    Private m_sVCardPhoneNumber

    Private m_sTimeZone
    Private m_sDeferredDeliveryTime

    Private m_nLifeTime

    Private m_sURLBufferedMessageNotification
    Private m_sURLDeliveryNotification
    Private m_sURLNonDeliveryNotification

    Private m_nNotificationInquirySettingsFormat
    Private m_sNotificationInquirySettingsSeparator

    Private m_sWAPPushDescription
    Private m_sWAPPushURL
    
    Private m_sDestinationUserKey
    Private m_nDestinationCredits

    Private m_nAffiliateId

    Private m_sRawXml

    Private oXmlDocRequest
    Private oXmlDocResponse
    Private oXmlHttp

    '--- Event Handlers ------------------------------------

    Private Sub Class_Initialize()
        '2004 by aspsms.com

        Randomize
        m_nRandomNumber = Int(Rnd()*2)+1

        If m_nRandomNumber/2 = Int(m_nRandomNumber/2) Then
            m_sXmlInterfaceUrl         = "http://xml1.aspsms.com:5061/xmlsvr.asp"
            m_sXmlServicesInterfaceUrl = "http://xml1.aspsms.com:5061/services.asp"
        Else
            m_sXmlInterfaceUrl         = "http://xml2.aspsms.com:5061/xmlsvr.asp"
            m_sXmlServicesInterfaceUrl = "http://xml2.aspsms.com:5061/services.asp"
        End If

        'create XML objects
        Set oXmlDocRequest  = CreateObject("MSXML2.DOMDocument")
        Set oXmlHttp        = CreateObject("MSXML2.XMLHTTP")
        Set oXmlDocResponse = CreateObject("MSXML2.DOMDocument")

    End Sub

    Private Sub Class_Terminate()
        '2004 by aspsms.com

        'destroy XML objects
        Set oXmlDocResponse = Nothing
        Set oXmlHttp        = Nothing
        Set oXmlDocRequest  = Nothing

    End Sub


    '--- Property Lets -------------------------------------

    Public Property Let XmlInterfaceUrl(sXmlInterfaceUrl)
        m_sXmlInterfaceUrl = sXmlInterfaceUrl
    End Property

    Public Property Let XmlServicesInterfaceUrl(sXmlServicesInterfaceUrl)
        m_sXmlServicesInterfaceUrl = sXmlServicesInterfaceUrl
    End Property

    Public Property Let PasswordFileLocation(sPasswordFileLocation)
        m_sPasswordFileLocation = sPasswordFileLocation
    End Property

    Public Property Let Userkey(sUserkey)
        m_sUserkey = sUserkey
    End Property

    Public Property Let Password(sPassword)
        m_sPassword = sPassword
    End Property

    Public Property Let UsedCredits(nUsedCredits)
        m_nUsedCredits = nUsedCredits
    End Property

    Public Property Let Originator(sOriginator)
        m_sOriginator = sOriginator
    End Property

    Public Property Let OriginatorUnlockCode(sOriginatorUnlockCode)
        m_sOriginatorUnlockCode = sOriginatorUnlockCode
    End Property

    Public Property Let FlashingSMS(bFlashingSMS)
        m_bFlashingSMS = bFlashingSMS
    End Property

    Public Property Let BlinkingSMS(bBlinkingSMS)
        m_bBlinkingSMS = bBlinkingSMS
    End Property

    Public Property Let ReplaceMessage(nReplaceMessage)
        m_nReplaceMessage = nReplaceMessage
    End Property

    Public Property Let MCC(nMCC)
        m_nMCC = nMCC
    End Property

    Public Property Let MNC(nMNC)
        m_nMNC = nMNC
    End Property

    Public Property Let URLBinaryFile(sURLBinaryFile)
        m_sURLBinaryFile = sURLBinaryFile
    End Property

    Public Property Let VCardName(sVCardName)
        m_sVCardName = sVCardName
    End Property

    Public Property Let VCardPhoneNumber(sVCardPhoneNumber)
        m_sVCardPhoneNumber = sVCardPhoneNumber
    End Property

    Public Property Let XSer(sXSer)
        m_sXSer = sXSer
    End Property

    Public Property Let MessageData(sMessageData)
        m_sMessageData = sMessageData
    End Property

    Public Property Let TimeZone(sTimeZone)
        m_sTimeZone = sTimeZone
    End Property

    Public Property Let DeferredDeliveryTime(sDeferredDeliveryTime)
        m_sDeferredDeliveryTime = sDeferredDeliveryTime
    End Property

    Public Property Let LifeTime(nLifeTime)
        m_nLifeTime = nLifeTime
    End Property

    Public Property Let URLBufferedMessageNotification(sURLBufferedMessageNotification)
        m_sURLBufferedMessageNotification = sURLBufferedMessageNotification
    End Property

    Public Property Let URLDeliveryNotification(sURLDeliveryNotification)
        m_sURLDeliveryNotification = sURLDeliveryNotification
    End Property

    Public Property Let URLNonDeliveryNotification(sURLNonDeliveryNotification)
        m_sURLNonDeliveryNotification = sURLNonDeliveryNotification
    End Property

    Public Property Let NotificationInquirySettingsFormat(nNotificationInquirySettingsFormat)
        m_nNotificationInquirySettingsFormat = nNotificationInquirySettingsFormat
    End Property

    Public Property Let NotificationInquirySettingsSeparator(sNotificationInquirySettingsSeparator)
        m_sNotificationInquirySettingsSeparator = sNotificationInquirySettingsSeparator
    End Property

    Public Property Let WAPPushDescription(sWAPPushDescription)
        m_sWAPPushDescription = sWAPPushDescription
    End Property

    Public Property Let WAPPushURL(sWAPPushURL)
        m_sWAPPushURL = sWAPPushURL
    End Property

    Public Property Let DestinationUserKey(sDestinationUserKey)
        m_sDestinationUserKey = sDestinationUserKey
    End Property

    Public Property Let DestinationCredits(nDestinationCredits)
        m_nDestinationCredits = nDestinationCredits
    End Property

    Public Property Let AffiliateId(nAffiliateId)
        m_nAffiliateId = nAffiliateId
    End Property

    Public Property Let RawXml(sRawXml)
        m_sRawXml = sRawXml
    End Property

    '--- Property Gets -------------------------------------

    Public Property Get XmlLog()
         XmlLog = m_sXmlLog
    End Property

    Public Property Get ErrorCode()
         ErrorCode = m_nErrorCode
    End Property

    Public Property Get ErrorDescription()
         ErrorDescription = m_sErrorDescription
    End Property

    '--- Private Methods -----------------------------------

    Private Function isoEncode(sString)
        '2004 by aspsms.com

        Dim i
        Dim sChar

        For i = 1 To Len(sString)

            sChar = Mid(sString, i, 1)

            Select Case True

                'character must be encoded
                '&, <, >, chr(128)-chr(255)
                Case Asc(sChar) = 38 OR _
                     Asc(sChar) = 60 OR _
                     Asc(sChar) = 62 OR _
                     (Asc(sChar) >= 128 AND Asc(sChar) <= 255)
                isoEncode = isoEncode & "&#" & Asc(sChar) & ";"

                'character must not be encoded
                Case Else
                isoEncode = isoEncode & sChar

            End Select

        Next 'i

    End Function

    Private Sub talkToXmlInterfaceForSend(byVal sXml)
        '2004 by aspsms.com

        Dim sResponseXml

        oXmlDocRequest.SetProperty "ServerHTTPRequest", False
        oXmlDocRequest.Async = False
        oXmlDocRequest.LoadXML(sXml)

        If oXmlDocRequest.ParseError = 0 Then
            oXmlHttp.Open "POST", m_sXmlInterfaceUrl, False
            oXmlHttp.Send oXmlDocRequest.xml
            sResponseXml = oXmlHttp.ResponseXML.xml

            m_sXmlLog = m_sXmlLog & vbCr & m_sXmlInterfaceUrl & vbCr
            m_sXmlLog = m_sXmlLog & vbCr & sResponseXml & vbCr

            oXmlDocResponse.setProperty "ServerHTTPRequest", True
            oXmlDocResponse.async = False
            oXmlDocResponse.LoadXML sResponseXml

            m_nErrorCode = CInt(oXmlDocResponse.getElementsByTagName("ErrorCode").item(0).text)
            m_sErrorDescription = oXmlDocResponse.getElementsByTagName("ErrorDescription").item(0).text

        Else
            m_nErrorCode = 99
            m_sErrorDescription = "XML ParseError"
        End If

    End Sub

    Private Sub talkToXmlServicesInterfaceForSend(byVal sXml)
        '2004 by aspsms.com

        Dim sResponseXml

        oXmlDocRequest.SetProperty "ServerHTTPRequest", False
        oXmlDocRequest.Async = False
        oXmlDocRequest.LoadXML(sXml)

        If oXmlDocRequest.ParseError = 0 Then
            oXmlHttp.Open "POST", m_sXmlServicesInterfaceUrl, False
            oXmlHttp.Send oXmlDocRequest.xml
            sResponseXml = oXmlHttp.ResponseXML.xml

            m_sXmlLog = m_sXmlLog & vbCr & sResponseXml & vbCr

            oXmlDocResponse.setProperty "ServerHTTPRequest", True
            oXmlDocResponse.async = False
            oXmlDocResponse.LoadXML sResponseXml

            'm_nErrorCode = CInt(oXmlDocResponse.getElementsByTagName("ErrorCode").item(0).text)
            'm_sErrorDescription = oXmlDocResponse.getElementsByTagName("ErrorDescription").item(0).text

            'Dump "sResponseXml = " & sResponseXml
            m_nErrorCode = CInt(oXmlDocResponse.getElementsByTagName("aspsms/Services/TransferCredits/TransferStatus").item(0).text)
            m_sErrorDescription = oXmlDocResponse.getElementsByTagName("aspsms/Services/TransferCredits/Message").item(0).text


        Else
            m_nErrorCode = 99
            m_sErrorDescription = "XML ParseError"
        End If

    End Sub

    Private Function setTimeZoneDeferredDeliveryTime()
        '2004 by aspsms.com
        If m_sTimeZone <> "" Then
            setTimeZoneDeferredDeliveryTime = setTimeZoneDeferredDeliveryTime & "  <TimeZone>" & m_sTimeZone & "</TimeZone>" & vbCr
        End If
        If m_sDeferredDeliveryTime <> "" Then
            setTimeZoneDeferredDeliveryTime = setTimeZoneDeferredDeliveryTime & "  <DeferredDeliveryTime>" & m_sDeferredDeliveryTime & "</DeferredDeliveryTime>" & vbCr
        End If
    End Function

    Private Function setLifeTime()
        '2005 by aspsms.com
        If m_nLifeTime <> "" Then
            setLifeTime = setLifeTime & "  <LifeTime>" & m_nLifeTime & "</LifeTime>" & vbCr
        End If
    End Function


    Private Function setNotificationURLs()
        '2004 by aspsms.com
        If m_sURLBufferedMessageNotification <> "" Then
            setNotificationURLs = setNotificationURLs & "  <URLBufferedMessageNotification>" & isoEncode(m_sURLBufferedMessageNotification) & "</URLBufferedMessageNotification>" & vbCr
        End If
        If m_sURLDeliveryNotification <> "" Then
            setNotificationURLs = setNotificationURLs & "  <URLDeliveryNotification>" & isoEncode(m_sURLDeliveryNotification) & "</URLDeliveryNotification>" & vbCr
        End If
        If m_sURLNonDeliveryNotification <> "" Then
            setNotificationURLs = setNotificationURLs & "  <URLNonDeliveryNotification>" & isoEncode(m_sURLNonDeliveryNotification) & "</URLNonDeliveryNotification>" & vbCr
        End If
    End Function


    Private Function setUserkeyPassword()
        '2004 by aspsms.com

        Dim sMyUserkey
        Dim sMyPassword

        Dim oFs
        Dim oF
        Dim sLine
        Dim sLineArray

        If m_sPasswordFileLocation <> "" Then
            Set oFs = Server.CreateObject("Scripting.FileSystemObject")
                If oFs.FileExists(m_sPasswordFileLocation) Then
                    Set oF = oFs.OpenTextFile(m_sPasswordFileLocation, 1)

                        '1. line (Userkey = XXXXXXXXXXXX)
                        sLine = oF.ReadLine
                        sLineArray = Split(sLine, "=")
                        sMyUserkey = Trim(sLineArray(1))

                        '2. Line (Password = XXXXXX)
                        sLine = oF.ReadLine
                        sLineArray = Split(sLine, "=")
                        sMyPassword = Trim(sLineArray(1))

                        oF.Close
                    Set oF = Nothing
                End If
            Set oFs = Nothing
        Else
            sMyUserkey  = m_sUserkey
            sMyPassword = m_sPassword
        End If

        setUserkeyPassword = setUserkeyPassword & "  <Userkey>" & isoEncode(sMyUserkey) & "</Userkey>" & vbCr
        setUserkeyPassword = setUserkeyPassword & "  <Password>" & isoEncode(sMyPassword) & "</Password>" & vbCr

    End Function

    Private Function setUserkeyPasswordServices()
        '2004 by aspsms.com

        Dim sMyUserkey
        Dim sMyPassword

        Dim oFs
        Dim oF
        Dim sLine
        Dim sLineArray

        If m_sPasswordFileLocation <> "" Then
            Set oFs = Server.CreateObject("Scripting.FileSystemObject")
                If oFs.FileExists(m_sPasswordFileLocation) Then
                    Set oF = oFs.OpenTextFile(m_sPasswordFileLocation, 1)

                        '1. line (Userkey = XXXXXXXXXXXX)
                        sLine = oF.ReadLine
                        sLineArray = Split(sLine, "=")
                        sMyUserkey = Trim(sLineArray(1))

                        '2. Line (Password = XXXXXX)
                        sLine = oF.ReadLine
                        sLineArray = Split(sLine, "=")
                        sMyPassword = Trim(sLineArray(1))

                        oF.Close
                    Set oF = Nothing
                End If
            Set oFs = Nothing
        Else
            sMyUserkey  = m_sUserkey
            sMyPassword = m_sPassword
        End If

        setUserkeyPasswordServices = setUserkeyPasswordServices & "        <UserKey>" & isoEncode(sMyUserkey) & "</UserKey>" & vbCr
        setUserkeyPasswordServices = setUserkeyPasswordServices & "        <Password>" & isoEncode(sMyPassword) & "</Password>" & vbCr

    End Function

    '--- Public Methods ------------------------------------

    Public Sub AddRecipient(byVal sPhoneNumber, byVal sTransRefNumber)
        '2004 by aspsms.com
        m_sXmlRecipients = m_sXmlRecipients & "  <Recipient>" & vbCr
        m_sXmlRecipients = m_sXmlRecipients & "    <PhoneNumber>" & sPhoneNumber & "</PhoneNumber>" & vbCr
        m_sXmlRecipients = m_sXmlRecipients & "    <TransRefNumber>" & sTransRefNumber & "</TransRefNumber>" & vbCr
        m_sXmlRecipients = m_sXmlRecipients & "  </Recipient>" & vbCr
    End Sub

    Public Sub DeleteAllRecipients()
        m_sXmlRecipients = ""
    End Sub

    Public Sub AddTransRefNumberForNotificationInquiry(byVal sTransRefNumber)
        '2004 by aspsms.com
        m_sXmlTransRefNumbers = m_sXmlTransRefNumbers & "  <TransRefNumber>" & isoEncode(sTransRefNumber) & "</TransRefNumber>" & vbCr
    End Sub


    Public Sub SendTextMessage()
        '2005 by aspsms.com

        Dim sXml

        m_sXmlLog = m_sXmlLog & vbCr & m_sXmlInterfaceUrl & vbCr

               sXml = "<?xml version=""1.0"" encoding=""ISO-8859-1""?>" & vbCr
        sXml = sXml & "<aspsms>" & vbCr
        sXml = sXml & setUserkeyPassword()
        sXml = sXml & m_sXmlRecipients
        If m_nAffiliateId <> "" Then
            sXml = sXml & "  <AffiliateId>" & m_nAffiliateId & "</AffiliateId>" & vbCr
        End If
        If CStr(m_nUsedCredits) = "1" Then
            sXml = sXml & "  <UsedCredits>" & m_nUsedCredits & "</UsedCredits>" & vbCr
        End If
        sXml = sXml & "  <Originator>" & m_sOriginator & "</Originator>" & vbCr
        If bFlashingSMS Then
            sXml = sXml & "  <FlashingSMS>1</FlashingSMS>" & vbCr
        End If
        If bBlinkingSMS Then
            sXml = sXml & "  <BlinkingSMS>1</BlinkingSMS>" & vbCr
        End If
        If m_nReplaceMessage <> "" Then
            sXml = sXml & "  <ReplaceMessage>" & m_nReplaceMessage & "</ReplaceMessage>" & vbCr
        End If
        'sXml = sXml & "  <MessageData>" & m_sMessageData & "</MessageData>" & vbCr
        sXml = sXml & "  <MessageData><![CDATA[" & m_sMessageData & "]]></MessageData>" & vbCr
        sXml = sXml & setTimeZoneDeferredDeliveryTime()
        sXml = sXml & setLifeTime()
        sXml = sXml & setNotificationURLs()
        sXml = sXml & "  <Action>SendTextSMS</Action>" & vbCr
        sXml = sXml & "</aspsms>"

        m_sXmlLog = m_sXmlLog & sXml & vbCr

        Call talkToXmlInterfaceForSend(sXml)

    End Sub


    Public Sub SendRandomLogo()
        '2005 by aspsms.com

        Dim sXml

        m_sXmlLog = m_sXmlLog & vbCr & m_sXmlInterfaceUrl & vbCr

               sXml = "<?xml version=""1.0"" encoding=""ISO-8859-1""?>" & vbCr
        sXml = sXml & "<aspsms>" & vbCr
        sXml = sXml & setUserkeyPassword()
        sXml = sXml & m_sXmlRecipients
        sXml = sXml & "  <Originator>" & m_sOriginator & "</Originator>" & vbCr
        sXml = sXml & setTimeZoneDeferredDeliveryTime()
        sXml = sXml & setLifeTime()
        sXml = sXml & setNotificationURLs()
        sXml = sXml & "  <Action>SendRandomLogo</Action>" & vbCr
        sXml = sXml & "</aspsms>"

        m_sXmlLog = m_sXmlLog & sXml & vbCr

        Call talkToXmlInterfaceForSend(sXml)

    End Sub


    Public Sub SendLogo()
        '2005 by aspsms.com

        Dim sXml

        m_sXmlLog = m_sXmlLog & vbCr & m_sXmlInterfaceUrl & vbCr

               sXml = "<?xml version=""1.0"" encoding=""ISO-8859-1""?>" & vbCr
        sXml = sXml & "<aspsms>" & vbCr
        sXml = sXml & setUserkeyPassword()
        sXml = sXml & m_sXmlRecipients
        sXml = sXml & "  <Originator>" & m_sOriginator & "</Originator>" & vbCr
        sXml = sXml & "  <URLBinaryFile>" & isoEncode(m_sURLBinaryFile) & "</URLBinaryFile>" & vbCr
        sXml = sXml & setTimeZoneDeferredDeliveryTime()
        sXml = sXml & setLifeTime()
        sXml = sXml & setNotificationURLs()
        sXml = sXml & "  <Action>SendLogo</Action>" & vbCr
        sXml = sXml & "</aspsms>"

        m_sXmlLog = m_sXmlLog & sXml & vbCr

        Call talkToXmlInterfaceForSend(sXml)

    End Sub

    Public Sub SendGroupLogo()
        '2005 by aspsms.com

        Dim sXml

        m_sXmlLog = m_sXmlLog & vbCr & m_sXmlInterfaceUrl & vbCr

               sXml = "<?xml version=""1.0"" encoding=""ISO-8859-1""?>" & vbCr
        sXml = sXml & "<aspsms>" & vbCr
        sXml = sXml & setUserkeyPassword()
        sXml = sXml & m_sXmlRecipients
        sXml = sXml & "  <Originator>" & m_sOriginator & "</Originator>" & vbCr
        sXml = sXml & "  <URLBinaryFile>" & isoEncode(m_sURLBinaryFile) & "</URLBinaryFile>" & vbCr
        sXml = sXml & setTimeZoneDeferredDeliveryTime()
        sXml = sXml & setLifeTime()
        sXml = sXml & setNotificationURLs()
        sXml = sXml & "  <Action>SendGroupLogo</Action>" & vbCr
        sXml = sXml & "</aspsms>"

        m_sXmlLog = m_sXmlLog & sXml & vbCr

        Call talkToXmlInterfaceForSend(sXml)

    End Sub

    Public Sub SendPictureMessage()
        '2005 by aspsms.com

        Dim sXml

        m_sXmlLog = m_sXmlLog & vbCr & m_sXmlInterfaceUrl & vbCr

               sXml = "<?xml version=""1.0"" encoding=""ISO-8859-1""?>" & vbCr
        sXml = sXml & "<aspsms>" & vbCr
        sXml = sXml & setUserkeyPassword()
        sXml = sXml & m_sXmlRecipients
        sXml = sXml & "  <Originator>" & m_sOriginator & "</Originator>" & vbCr
        sXml = sXml & "  <URLBinaryFile>" & isoEncode(m_sURLBinaryFile) & "</URLBinaryFile>" & vbCr
        sXml = sXml & setTimeZoneDeferredDeliveryTime()
        sXml = sXml & setLifeTime()
        sXml = sXml & setNotificationURLs()
        sXml = sXml & "  <Action>SendPictureMessage</Action>" & vbCr
        sXml = sXml & "</aspsms>"

        m_sXmlLog = m_sXmlLog & sXml & vbCr

        Call talkToXmlInterfaceForSend(sXml)

    End Sub


    Public Sub SendRingtone()
        '2005 by aspsms.com

        Dim sXml

        m_sXmlLog = m_sXmlLog & vbCr & m_sXmlInterfaceUrl & vbCr

               sXml = "<?xml version=""1.0"" encoding=""ISO-8859-1""?>" & vbCr
        sXml = sXml & "<aspsms>" & vbCr
        sXml = sXml & setUserkeyPassword()
        sXml = sXml & m_sXmlRecipients
        sXml = sXml & "  <Originator>" & m_sOriginator & "</Originator>" & vbCr
        sXml = sXml & "  <URLBinaryFile>" & isoEncode(m_sURLBinaryFile) & "</URLBinaryFile>" & vbCr
        sXml = sXml & setTimeZoneDeferredDeliveryTime()
        sXml = sXml & setLifeTime()
        sXml = sXml & setNotificationURLs()
        sXml = sXml & "  <Action>SendRingtone</Action>" & vbCr
        sXml = sXml & "</aspsms>"

        m_sXmlLog = m_sXmlLog & sXml & vbCr

        Call talkToXmlInterfaceForSend(sXml)

    End Sub

    Public Sub SendVCard()
        '2005 by aspsms.com

        Dim sXml

        m_sXmlLog = m_sXmlLog & vbCr & m_sXmlInterfaceUrl & vbCr

               sXml = "<?xml version=""1.0"" encoding=""ISO-8859-1""?>" & vbCr
        sXml = sXml & "<aspsms>" & vbCr
        sXml = sXml & setUserkeyPassword()
        sXml = sXml & m_sXmlRecipients
        sXml = sXml & "  <Originator>" & m_sOriginator & "</Originator>" & vbCr
        sXml = sXml & "  <VCard>" & vbCr
        sXml = sXml & "    <VName>" & isoEncode(m_sVCardName) & "</VName>" & vbCr
        sXml = sXml & "    <VPhoneNumber>" & isoEncode(m_sVCardPhoneNumber) & "</VPhoneNumber>" & vbCr
        sXml = sXml & "  </VCard>" & vbCr
        sXml = sXml & setTimeZoneDeferredDeliveryTime()
        sXml = sXml & setLifeTime()
        sXml = sXml & setNotificationURLs()
        sXml = sXml & "  <Action>SendVCard</Action>" & vbCr
        sXml = sXml & "</aspsms>"

        m_sXmlLog = m_sXmlLog & sXml & vbCr

        Call talkToXmlInterfaceForSend(sXml)

    End Sub


    Public Sub SendBinaryData()
        '2005 by aspsms.com

        Dim sXml

        m_sXmlLog = m_sXmlLog & vbCr & m_sXmlInterfaceUrl & vbCr

               sXml = "<?xml version=""1.0"" encoding=""ISO-8859-1""?>" & vbCr
        sXml = sXml & "<aspsms>" & vbCr
        sXml = sXml & setUserkeyPassword()
        sXml = sXml & m_sXmlRecipients
        sXml = sXml & "  <Originator>" & m_sOriginator & "</Originator>" & vbCr
        sXml = sXml & "  <XSer>" & isoEncode(m_sXSer) & "</XSer>" & vbCr
        sXml = sXml & "  <MessageData>" & isoEncode(m_sMessageData) & "</MessageData>" & vbCr
        sXml = sXml & setTimeZoneDeferredDeliveryTime()
        sXml = sXml & setLifeTime()
        sXml = sXml & setNotificationURLs()
        sXml = sXml & "  <Action>SendBinaryData</Action>" & vbCr
        sXml = sXml & "</aspsms>"

        m_sXmlLog = m_sXmlLog & sXml & vbCr

        Call talkToXmlInterfaceForSend(sXml)

    End Sub


    Public Function InquireDeliveryNotifications()
        '2004 by aspsms.com

        Dim sXml
        Dim sResponseXml

        Dim oDeliveryNotifications
        Dim oDeliveryNotification

        Dim sTransRefNumber
        Dim nDeliveryStatus
        Dim sSubmissionDate
        Dim sNotification
        Dim sReasonCode

        m_sXmlLog = m_sXmlLog & vbCr & m_sXmlInterfaceUrl & vbCr

               sXml = "<?xml version=""1.0"" encoding=""ISO-8859-1""?>" & vbCr
        sXml = sXml & "<aspsms>" & vbCr
        sXml = sXml & setUserkeyPassword()
        sXml = sXml & m_sXmlTransRefNumbers
        sXml = sXml & "  <Action>InquireDeliveryNotifications</Action>" & vbCr
        sXml = sXml & "</aspsms>"

        m_sXmlLog = m_sXmlLog & sXml & vbCr

        oXmlDocRequest.SetProperty "ServerHTTPRequest", False
        oXmlDocRequest.Async = False
        oXmlDocRequest.LoadXML(sXml)

        If oXmlDocRequest.ParseError = 0 Then
            oXmlHttp.Open "POST", m_sXmlInterfaceUrl, False
            oXmlHttp.Send oXmlDocRequest.xml
            sResponseXml = oXmlHttp.ResponseXML.xml

            m_sXmlLog = m_sXmlLog & vbCr & sResponseXml & vbCr

            oXmlDocResponse.setProperty "ServerHTTPRequest", True
            oXmlDocResponse.async = False
            oXmlDocResponse.LoadXML sResponseXml

            m_nErrorCode = CInt(oXmlDocResponse.getElementsByTagName("ErrorCode").item(0).text)
            m_sErrorDescription = oXmlDocResponse.getElementsByTagName("ErrorDescription").item(0).text

            If m_nErrorCode = 1 Then
                Set oDeliveryNotifications = oXmlDocResponse.getElementsByTagName("aspsms/DeliveryNotification")

                    For Each oDeliveryNotification In oDeliveryNotifications

                        sTransRefNumber = oDeliveryNotification.childNodes(0).text
                        nDeliveryStatus = oDeliveryNotification.childNodes(1).text
                        sSubmissionDate = oDeliveryNotification.childNodes(2).text
                        sNotification   = oDeliveryNotification.childNodes(3).text
                        sReasonCode     = oDeliveryNotification.childNodes(4).text

                        Select Case m_nNotificationInquirySettingsFormat

                            Case 1
                            InquireDeliveryNotifications = InquireDeliveryNotifications & sTransRefNumber & m_sNotificationInquirySettingsSeparator & _
                                                           nDeliveryStatus & m_sNotificationInquirySettingsSeparator & _
                                                           sSubmissionDate & m_sNotificationInquirySettingsSeparator & _
                                                           sNotification   & m_sNotificationInquirySettingsSeparator & _
                                                           sReasonCode     & m_sNotificationInquirySettingsSeparator

                            Case 2
                            InquireDeliveryNotifications = InquireDeliveryNotifications & sTransRefNumber & m_sNotificationInquirySettingsSeparator & _
                                                           nDeliveryStatus & vbCrLf

                            Case 3
                            InquireDeliveryNotifications = InquireDeliveryNotifications & sTransRefNumber & m_sNotificationInquirySettingsSeparator & _
                                                           nDeliveryStatus & m_sNotificationInquirySettingsSeparator

                            Case Else '0 = Default
                            InquireDeliveryNotifications = InquireDeliveryNotifications & sTransRefNumber & m_sNotificationInquirySettingsSeparator & _
                                                           nDeliveryStatus & m_sNotificationInquirySettingsSeparator & _
                                                           sSubmissionDate & m_sNotificationInquirySettingsSeparator & _
                                                           sNotification   & m_sNotificationInquirySettingsSeparator & _
                                                           sReasonCode     & vbCrLf

                        End Select

                    Next

                Set oDeliveryNotifications = Nothing
            End If

        Else
            m_nErrorCode = 99
            m_sErrorDescription = "XML ParseError"
        End If

    End Function


    Public Function Credits()
        '2004 by aspsms.com

        Dim sXml
        Dim sResponseXml

        Dim oFilesystem
        Dim oFile

        m_sXmlLog = m_sXmlLog & vbCr & m_sXmlInterfaceUrl & vbCr

               sXml = "<?xml version=""1.0"" encoding=""ISO-8859-1""?>" & vbCr
        sXml = sXml & "<aspsms>" & vbCr
        sXml = sXml & setUserkeyPassword()
        sXml = sXml & "  <Action>ShowCredits</Action>" & vbCr
        sXml = sXml & "</aspsms>"

        m_sXmlLog = m_sXmlLog & sXml & vbCr

        oXmlDocRequest.SetProperty "ServerHTTPRequest", False
        oXmlDocRequest.Async = False
        oXmlDocRequest.LoadXML(sXml)

        If oXmlDocRequest.ParseError = 0 Then
            oXmlHttp.Open "POST", m_sXmlInterfaceUrl, False
            oXmlHttp.Send oXmlDocRequest.xml
            sResponseXml = oXmlHttp.ResponseXML.xml

            m_sXmlLog = m_sXmlLog & vbCr & sResponseXml & vbCr

            oXmlDocResponse.setProperty "ServerHTTPRequest", True
            oXmlDocResponse.async = False
            oXmlDocResponse.LoadXML sResponseXml
            
            'On Error Resume Next
            m_nErrorCode = CInt(oXmlDocResponse.getElementsByTagName("ErrorCode").item(0).text & "")
            m_sErrorDescription = oXmlDocResponse.getElementsByTagName("ErrorDescription").item(0).text
            'If Err.Number <> 0 Then
            '    Dump Err.Number & ": " & Err.Description
            'End If
            'On Error Goto 0

            If m_nErrorCode = "1" Then
                Credits = oXmlDocResponse.getElementsByTagName("Credits").item(0).text
            End If

        Else
            m_nErrorCode = 99
            m_sErrorDescription = "XML ParseError"
        End If

    End Function

    Public Sub SendWAPPushSMS()
        '2005 by aspsms.com

        Dim sXml

        m_sXmlLog = m_sXmlLog & vbCr & m_sXmlInterfaceUrl & vbCr

               sXml = "<?xml version=""1.0"" encoding=""ISO-8859-1""?>" & vbCr
        sXml = sXml & "<aspsms>" & vbCr
        sXml = sXml & setUserkeyPassword()
        sXml = sXml & m_sXmlRecipients
        sXml = sXml & "  <Originator>" & m_sOriginator & "</Originator>" & vbCr
        sXml = sXml & "  <WAPPushDescription>" & isoEncode(m_sWAPPushDescription) & "</WAPPushDescription>" & vbCr
        sXml = sXml & "  <WAPPushURL>" & isoEncode(m_sWAPPushURL) & "</WAPPushURL>" & vbCr
        sXml = sXml & setTimeZoneDeferredDeliveryTime()
        sXml = sXml & setLifeTime()
        sXml = sXml & setNotificationURLs()
        sXml = sXml & "  <Action>SendWAPPushSMS</Action>" & vbCr
        sXml = sXml & "</aspsms>"

        m_sXmlLog = m_sXmlLog & sXml & vbCr

        Call talkToXmlInterfaceForSend(sXml)

    End Sub

    Public Sub CheckOriginatorAuthorization()
        '2005 by aspsms.com

        Dim sXml

        m_sXmlLog = m_sXmlLog & vbCr & m_sXmlInterfaceUrl & vbCr

               sXml = "<?xml version=""1.0"" encoding=""ISO-8859-1""?>" & vbCr
        sXml = sXml & "<aspsms>" & vbCr
        sXml = sXml & setUserkeyPassword()
        sXml = sXml & "  <Originator>" & m_sOriginator & "</Originator>" & vbCr
        sXml = sXml & "  <Action>CheckOriginatorAuthorization</Action>" & vbCr
        sXml = sXml & "</aspsms>"

        m_sXmlLog = m_sXmlLog & sXml & vbCr

        Call talkToXmlInterfaceForSend(sXml)

    End Sub

    Public Sub SendOriginatorUnlockCode()
        '2005 by aspsms.com

        Dim sXml

        m_sXmlLog = m_sXmlLog & vbCr & m_sXmlInterfaceUrl & vbCr

               sXml = "<?xml version=""1.0"" encoding=""ISO-8859-1""?>" & vbCr
        sXml = sXml & "<aspsms>" & vbCr
        sXml = sXml & setUserkeyPassword()
        sXml = sXml & "  <MessageData><![CDATA[" & m_sMessageData & "]]></MessageData>" & vbCr
        sXml = sXml & "  <Originator>" & m_sOriginator & "</Originator>" & vbCr
        sXml = sXml & "  <Action>SendOriginatorUnlockCode</Action>" & vbCr
        sXml = sXml & "</aspsms>"

        m_sXmlLog = m_sXmlLog & sXml & vbCr

        Call talkToXmlInterfaceForSend(sXml)

    End Sub

    Public Sub UnlockOriginator()
        '2005 by aspsms.com

        Dim sXml

        m_sXmlLog = m_sXmlLog & vbCr & m_sXmlInterfaceUrl & vbCr

               sXml = "<?xml version=""1.0"" encoding=""ISO-8859-1""?>" & vbCr
        sXml = sXml & "<aspsms>" & vbCr
        sXml = sXml & setUserkeyPassword()
        sXml = sXml & "  <OriginatorUnlockCode>" & m_sOriginatorUnlockCode & "</OriginatorUnlockCode>" & vbCr
        sXml = sXml & "  <Originator>" & m_sOriginator & "</Originator>" & vbCr
        sXml = sXml & "  <Action>UnlockOriginator</Action>" & vbCr
        sXml = sXml & "</aspsms>"

        m_sXmlLog = m_sXmlLog & sXml & vbCr

        Call talkToXmlInterfaceForSend(sXml)

    End Sub

    Public Sub TransferCredits()

        Dim sXml

        m_sXmlLog = m_sXmlLog & vbCr & m_sXmlServicesInterfaceUrl & vbCr

               sXml = "<?xml version=""1.0"" encoding=""ISO-8859-1""?>" & vbCr
        sXml = sXml & "<aspsms>" & vbCr
        sXml = sXml & "  <Services>" & vbCr
        sXml = sXml & "    <TransferCredits>" & vbCr
        sXml = sXml & "      <Source>" & vbCr
        sXml = sXml & setUserkeyPasswordServices()
        sXml = sXml & "      </Source>" & vbCr
        sXml = sXml & "      <Destination>" & vbCr
        sXml = sXml & "        <UserKey>" & m_sDestinationUserKey & "</UserKey>" & vbCr
        sXml = sXml & "        <Credits>" & m_nDestinationCredits & "</Credits>" & vbCr
        sXml = sXml & "      </Destination>" & vbCr
        sXml = sXml & "    </TransferCredits>" & vbCr
        sXml = sXml & "  </Services>" & vbCr
        sXml = sXml & "</aspsms>"

        m_sXmlLog = m_sXmlLog & sXml & vbCr

        Call talkToXmlServicesInterfaceForSend(sXml)

    End Sub

    Public Sub PostRawXmlXmlsvr()

        m_sXmlLog = m_sXmlLog & vbCr & m_sXmlInterfaceUrl & vbCr
        m_sXmlLog = m_sXmlLog & m_sRawXml & vbCr

        Dim sResponseXml

        oXmlDocRequest.SetProperty "ServerHTTPRequest", False
        oXmlDocRequest.Async = False
        oXmlDocRequest.LoadXML(m_sRawXml)

        If oXmlDocRequest.ParseError = 0 Then
            oXmlHttp.Open "POST", m_sXmlInterfaceUrl, False
            oXmlHttp.Send oXmlDocRequest.xml
            sResponseXml = oXmlHttp.ResponseXML.xml

            m_sXmlLog = m_sXmlLog & vbCr & sResponseXml & vbCr

        Else
            m_nErrorCode = 99
            m_sErrorDescription = "XML ParseError"
        End If


    End Sub

    Public Sub PostRawXmlServices()

        m_sXmlLog = m_sXmlLog & vbCr & m_sXmlServicesInterfaceUrl & vbCr
        m_sXmlLog = m_sXmlLog & m_sRawXml & vbCr

        Dim sResponseXml

        oXmlDocRequest.SetProperty "ServerHTTPRequest", False
        oXmlDocRequest.Async = False
        oXmlDocRequest.LoadXML(m_sRawXml)

        If oXmlDocRequest.ParseError = 0 Then
            oXmlHttp.Open "POST", m_sXmlServicesInterfaceUrl, False
            oXmlHttp.Send oXmlDocRequest.xml
            sResponseXml = oXmlHttp.ResponseXML.xml

            m_sXmlLog = m_sXmlLog & vbCr & sResponseXml & vbCr

        Else
            m_nErrorCode = 99
            m_sErrorDescription = "XML ParseError"
        End If


    End Sub

End Class
%>